// Code generated by mockery v2.42.3. DO NOT EDIT.

package mock_storage

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	storage "gitlab.com/commonground/nlx/fsc-nlx/controller/adapters/storage"

	url "net/url"
)

// MockStorage is an autogenerated mock type for the Storage type
type MockStorage struct {
	mock.Mock
}

type MockStorage_Expecter struct {
	mock *mock.Mock
}

func (_m *MockStorage) EXPECT() *MockStorage_Expecter {
	return &MockStorage_Expecter{mock: &_m.Mock}
}

// CreateService provides a mock function with given fields: ctx, args
func (_m *MockStorage) CreateService(ctx context.Context, args *storage.CreateServiceArgs) error {
	ret := _m.Called(ctx, args)

	if len(ret) == 0 {
		panic("no return value specified for CreateService")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *storage.CreateServiceArgs) error); ok {
		r0 = rf(ctx, args)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockStorage_CreateService_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'CreateService'
type MockStorage_CreateService_Call struct {
	*mock.Call
}

// CreateService is a helper method to define mock.On call
//   - ctx context.Context
//   - args *storage.CreateServiceArgs
func (_e *MockStorage_Expecter) CreateService(ctx interface{}, args interface{}) *MockStorage_CreateService_Call {
	return &MockStorage_CreateService_Call{Call: _e.mock.On("CreateService", ctx, args)}
}

func (_c *MockStorage_CreateService_Call) Run(run func(ctx context.Context, args *storage.CreateServiceArgs)) *MockStorage_CreateService_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(*storage.CreateServiceArgs))
	})
	return _c
}

func (_c *MockStorage_CreateService_Call) Return(_a0 error) *MockStorage_CreateService_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockStorage_CreateService_Call) RunAndReturn(run func(context.Context, *storage.CreateServiceArgs) error) *MockStorage_CreateService_Call {
	_c.Call.Return(run)
	return _c
}

// DeleteService provides a mock function with given fields: ctx, args
func (_m *MockStorage) DeleteService(ctx context.Context, args *storage.DeleteServiceArgs) error {
	ret := _m.Called(ctx, args)

	if len(ret) == 0 {
		panic("no return value specified for DeleteService")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *storage.DeleteServiceArgs) error); ok {
		r0 = rf(ctx, args)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockStorage_DeleteService_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'DeleteService'
type MockStorage_DeleteService_Call struct {
	*mock.Call
}

// DeleteService is a helper method to define mock.On call
//   - ctx context.Context
//   - args *storage.DeleteServiceArgs
func (_e *MockStorage_Expecter) DeleteService(ctx interface{}, args interface{}) *MockStorage_DeleteService_Call {
	return &MockStorage_DeleteService_Call{Call: _e.mock.On("DeleteService", ctx, args)}
}

func (_c *MockStorage_DeleteService_Call) Run(run func(ctx context.Context, args *storage.DeleteServiceArgs)) *MockStorage_DeleteService_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(*storage.DeleteServiceArgs))
	})
	return _c
}

func (_c *MockStorage_DeleteService_Call) Return(_a0 error) *MockStorage_DeleteService_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockStorage_DeleteService_Call) RunAndReturn(run func(context.Context, *storage.DeleteServiceArgs) error) *MockStorage_DeleteService_Call {
	_c.Call.Return(run)
	return _c
}

// GetService provides a mock function with given fields: ctx, groupID, serviceName
func (_m *MockStorage) GetService(ctx context.Context, groupID string, serviceName string) (*storage.Service, error) {
	ret := _m.Called(ctx, groupID, serviceName)

	if len(ret) == 0 {
		panic("no return value specified for GetService")
	}

	var r0 *storage.Service
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string) (*storage.Service, error)); ok {
		return rf(ctx, groupID, serviceName)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string, string) *storage.Service); ok {
		r0 = rf(ctx, groupID, serviceName)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*storage.Service)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string, string) error); ok {
		r1 = rf(ctx, groupID, serviceName)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockStorage_GetService_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'GetService'
type MockStorage_GetService_Call struct {
	*mock.Call
}

// GetService is a helper method to define mock.On call
//   - ctx context.Context
//   - groupID string
//   - serviceName string
func (_e *MockStorage_Expecter) GetService(ctx interface{}, groupID interface{}, serviceName interface{}) *MockStorage_GetService_Call {
	return &MockStorage_GetService_Call{Call: _e.mock.On("GetService", ctx, groupID, serviceName)}
}

func (_c *MockStorage_GetService_Call) Run(run func(ctx context.Context, groupID string, serviceName string)) *MockStorage_GetService_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(string), args[2].(string))
	})
	return _c
}

func (_c *MockStorage_GetService_Call) Return(_a0 *storage.Service, _a1 error) *MockStorage_GetService_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockStorage_GetService_Call) RunAndReturn(run func(context.Context, string, string) (*storage.Service, error)) *MockStorage_GetService_Call {
	_c.Call.Return(run)
	return _c
}

// ListInways provides a mock function with given fields: ctx, groupID
func (_m *MockStorage) ListInways(ctx context.Context, groupID string) ([]*storage.Inway, error) {
	ret := _m.Called(ctx, groupID)

	if len(ret) == 0 {
		panic("no return value specified for ListInways")
	}

	var r0 []*storage.Inway
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) ([]*storage.Inway, error)); ok {
		return rf(ctx, groupID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) []*storage.Inway); ok {
		r0 = rf(ctx, groupID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*storage.Inway)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, groupID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockStorage_ListInways_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'ListInways'
type MockStorage_ListInways_Call struct {
	*mock.Call
}

// ListInways is a helper method to define mock.On call
//   - ctx context.Context
//   - groupID string
func (_e *MockStorage_Expecter) ListInways(ctx interface{}, groupID interface{}) *MockStorage_ListInways_Call {
	return &MockStorage_ListInways_Call{Call: _e.mock.On("ListInways", ctx, groupID)}
}

func (_c *MockStorage_ListInways_Call) Run(run func(ctx context.Context, groupID string)) *MockStorage_ListInways_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(string))
	})
	return _c
}

func (_c *MockStorage_ListInways_Call) Return(_a0 []*storage.Inway, _a1 error) *MockStorage_ListInways_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockStorage_ListInways_Call) RunAndReturn(run func(context.Context, string) ([]*storage.Inway, error)) *MockStorage_ListInways_Call {
	_c.Call.Return(run)
	return _c
}

// ListOutways provides a mock function with given fields: ctx, groupID
func (_m *MockStorage) ListOutways(ctx context.Context, groupID string) ([]*storage.Outway, error) {
	ret := _m.Called(ctx, groupID)

	if len(ret) == 0 {
		panic("no return value specified for ListOutways")
	}

	var r0 []*storage.Outway
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) ([]*storage.Outway, error)); ok {
		return rf(ctx, groupID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) []*storage.Outway); ok {
		r0 = rf(ctx, groupID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*storage.Outway)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, groupID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockStorage_ListOutways_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'ListOutways'
type MockStorage_ListOutways_Call struct {
	*mock.Call
}

// ListOutways is a helper method to define mock.On call
//   - ctx context.Context
//   - groupID string
func (_e *MockStorage_Expecter) ListOutways(ctx interface{}, groupID interface{}) *MockStorage_ListOutways_Call {
	return &MockStorage_ListOutways_Call{Call: _e.mock.On("ListOutways", ctx, groupID)}
}

func (_c *MockStorage_ListOutways_Call) Run(run func(ctx context.Context, groupID string)) *MockStorage_ListOutways_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(string))
	})
	return _c
}

func (_c *MockStorage_ListOutways_Call) Return(_a0 []*storage.Outway, _a1 error) *MockStorage_ListOutways_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockStorage_ListOutways_Call) RunAndReturn(run func(context.Context, string) ([]*storage.Outway, error)) *MockStorage_ListOutways_Call {
	_c.Call.Return(run)
	return _c
}

// ListServices provides a mock function with given fields: ctx, groupID
func (_m *MockStorage) ListServices(ctx context.Context, groupID string) (storage.Services, error) {
	ret := _m.Called(ctx, groupID)

	if len(ret) == 0 {
		panic("no return value specified for ListServices")
	}

	var r0 storage.Services
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (storage.Services, error)); ok {
		return rf(ctx, groupID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) storage.Services); ok {
		r0 = rf(ctx, groupID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(storage.Services)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, groupID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockStorage_ListServices_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'ListServices'
type MockStorage_ListServices_Call struct {
	*mock.Call
}

// ListServices is a helper method to define mock.On call
//   - ctx context.Context
//   - groupID string
func (_e *MockStorage_Expecter) ListServices(ctx interface{}, groupID interface{}) *MockStorage_ListServices_Call {
	return &MockStorage_ListServices_Call{Call: _e.mock.On("ListServices", ctx, groupID)}
}

func (_c *MockStorage_ListServices_Call) Run(run func(ctx context.Context, groupID string)) *MockStorage_ListServices_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(string))
	})
	return _c
}

func (_c *MockStorage_ListServices_Call) Return(_a0 storage.Services, _a1 error) *MockStorage_ListServices_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockStorage_ListServices_Call) RunAndReturn(run func(context.Context, string) (storage.Services, error)) *MockStorage_ListServices_Call {
	_c.Call.Return(run)
	return _c
}

// Ping provides a mock function with given fields: ctx
func (_m *MockStorage) Ping(ctx context.Context) error {
	ret := _m.Called(ctx)

	if len(ret) == 0 {
		panic("no return value specified for Ping")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context) error); ok {
		r0 = rf(ctx)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockStorage_Ping_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Ping'
type MockStorage_Ping_Call struct {
	*mock.Call
}

// Ping is a helper method to define mock.On call
//   - ctx context.Context
func (_e *MockStorage_Expecter) Ping(ctx interface{}) *MockStorage_Ping_Call {
	return &MockStorage_Ping_Call{Call: _e.mock.On("Ping", ctx)}
}

func (_c *MockStorage_Ping_Call) Run(run func(ctx context.Context)) *MockStorage_Ping_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context))
	})
	return _c
}

func (_c *MockStorage_Ping_Call) Return(_a0 error) *MockStorage_Ping_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockStorage_Ping_Call) RunAndReturn(run func(context.Context) error) *MockStorage_Ping_Call {
	_c.Call.Return(run)
	return _c
}

// RegisterInway provides a mock function with given fields: ctx, groupID, name, address
func (_m *MockStorage) RegisterInway(ctx context.Context, groupID string, name string, address *url.URL) error {
	ret := _m.Called(ctx, groupID, name, address)

	if len(ret) == 0 {
		panic("no return value specified for RegisterInway")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string, *url.URL) error); ok {
		r0 = rf(ctx, groupID, name, address)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockStorage_RegisterInway_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'RegisterInway'
type MockStorage_RegisterInway_Call struct {
	*mock.Call
}

// RegisterInway is a helper method to define mock.On call
//   - ctx context.Context
//   - groupID string
//   - name string
//   - address *url.URL
func (_e *MockStorage_Expecter) RegisterInway(ctx interface{}, groupID interface{}, name interface{}, address interface{}) *MockStorage_RegisterInway_Call {
	return &MockStorage_RegisterInway_Call{Call: _e.mock.On("RegisterInway", ctx, groupID, name, address)}
}

func (_c *MockStorage_RegisterInway_Call) Run(run func(ctx context.Context, groupID string, name string, address *url.URL)) *MockStorage_RegisterInway_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(string), args[2].(string), args[3].(*url.URL))
	})
	return _c
}

func (_c *MockStorage_RegisterInway_Call) Return(_a0 error) *MockStorage_RegisterInway_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockStorage_RegisterInway_Call) RunAndReturn(run func(context.Context, string, string, *url.URL) error) *MockStorage_RegisterInway_Call {
	_c.Call.Return(run)
	return _c
}

// RegisterOutway provides a mock function with given fields: ctx, groupID, name, publicKeyThumbprint
func (_m *MockStorage) RegisterOutway(ctx context.Context, groupID string, name string, publicKeyThumbprint string) error {
	ret := _m.Called(ctx, groupID, name, publicKeyThumbprint)

	if len(ret) == 0 {
		panic("no return value specified for RegisterOutway")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string, string) error); ok {
		r0 = rf(ctx, groupID, name, publicKeyThumbprint)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockStorage_RegisterOutway_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'RegisterOutway'
type MockStorage_RegisterOutway_Call struct {
	*mock.Call
}

// RegisterOutway is a helper method to define mock.On call
//   - ctx context.Context
//   - groupID string
//   - name string
//   - publicKeyThumbprint string
func (_e *MockStorage_Expecter) RegisterOutway(ctx interface{}, groupID interface{}, name interface{}, publicKeyThumbprint interface{}) *MockStorage_RegisterOutway_Call {
	return &MockStorage_RegisterOutway_Call{Call: _e.mock.On("RegisterOutway", ctx, groupID, name, publicKeyThumbprint)}
}

func (_c *MockStorage_RegisterOutway_Call) Run(run func(ctx context.Context, groupID string, name string, publicKeyThumbprint string)) *MockStorage_RegisterOutway_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(string), args[2].(string), args[3].(string))
	})
	return _c
}

func (_c *MockStorage_RegisterOutway_Call) Return(_a0 error) *MockStorage_RegisterOutway_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockStorage_RegisterOutway_Call) RunAndReturn(run func(context.Context, string, string, string) error) *MockStorage_RegisterOutway_Call {
	_c.Call.Return(run)
	return _c
}

// UpdateService provides a mock function with given fields: ctx, args
func (_m *MockStorage) UpdateService(ctx context.Context, args *storage.UpdateServiceArgs) error {
	ret := _m.Called(ctx, args)

	if len(ret) == 0 {
		panic("no return value specified for UpdateService")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *storage.UpdateServiceArgs) error); ok {
		r0 = rf(ctx, args)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockStorage_UpdateService_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'UpdateService'
type MockStorage_UpdateService_Call struct {
	*mock.Call
}

// UpdateService is a helper method to define mock.On call
//   - ctx context.Context
//   - args *storage.UpdateServiceArgs
func (_e *MockStorage_Expecter) UpdateService(ctx interface{}, args interface{}) *MockStorage_UpdateService_Call {
	return &MockStorage_UpdateService_Call{Call: _e.mock.On("UpdateService", ctx, args)}
}

func (_c *MockStorage_UpdateService_Call) Run(run func(ctx context.Context, args *storage.UpdateServiceArgs)) *MockStorage_UpdateService_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(*storage.UpdateServiceArgs))
	})
	return _c
}

func (_c *MockStorage_UpdateService_Call) Return(_a0 error) *MockStorage_UpdateService_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockStorage_UpdateService_Call) RunAndReturn(run func(context.Context, *storage.UpdateServiceArgs) error) *MockStorage_UpdateService_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockStorage creates a new instance of MockStorage. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockStorage(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockStorage {
	mock := &MockStorage{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
